program somma_vettori

implicit none

integer, parameter        :: double = 8

integer                   :: i,n,np,ierr,np_avail,myid
real(double)              :: harvest,T
real(double), allocatable :: u(:),v(:),w(:)

integer                   :: omp_get_num_procs,omp_get_thread_num
real(double)              :: omp_get_wtime

np_avail = omp_get_num_procs()
write(*,*) 'Numero di processori disponibili:',np_avail

write(*,*) 'Inserire il numero di elementi'
read(*,*) n
write(*,*) 'Inserire il numero di threads'
read(*,*) np

allocate(u(n),v(n),w(n),stat=ierr)
if (ierr /= 0) stop 'ERRORE ALLOCAZIONE'

T = omp_get_wtime()
call random_seed()
do i = 1,n
   call random_number(harvest)
   v(i) = harvest
   call random_number(harvest)
   w(i) = harvest
enddo
T = omp_get_wtime() - T

write(*,*) 'Tempo random:',T

T = omp_get_wtime()
!$OMP parallel private(myid) num_threads(np)
myid = omp_get_thread_num() + 1
!$OMP do private(i)
do i = 1,n
   u(i) = 1.d-5*(exp(v(i)) + log(abs(w(i)))) + myid*1000
enddo
!$OMP end do
!$OMP end parallel
T = omp_get_wtime() - T

write(*,*) 'Tempo wall:',T

do i = 1,n,1000
   write(999,'(i3,3e15.6)') i,v(i),w(i),u(i)
enddo

end program somma_vettori
